#region Copyright Syncfusion Inc. 2001-2018.
// Copyright Syncfusion Inc. 2001-2018. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Controls.Grid;
using Syncfusion.Windows.Shared;
using Syncfusion.Windows.Controls.Cells;
using Syncfusion.Windows.Controls.Gantt;

namespace CellEditorsDemo
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MainWindow"/> class.
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();
        }

        private void InternalGrid_CurrentCellChanged(object sender, Syncfusion.Windows.ComponentModel.SyncfusionRoutedEventArgs args)
        {
            RowColumnIndex rci = this.Gantt.GanttGrid.InternalGrid.CurrentCell.CellRowColumnIndex;

            if (this.Gantt.GanttGrid.InternalGrid.Model.SelectedRanges.Count > 0)
            {
                for (int x = 0; x < this.Gantt.GanttGrid.InternalGrid.Model.SelectedRanges.Count; x++)
                {
                    for (int i = this.Gantt.GanttGrid.InternalGrid.Model.SelectedRanges[x].Top; i <= this.Gantt.GanttGrid.InternalGrid.Model.SelectedRanges[x].Bottom; i++)
                    {
                        if (i != rci.RowIndex)
                        {
                            if (rci.ColumnIndex == 2)//FirstName
                            {
                               var text = "";
                               text = this.Gantt.GanttGrid.InternalGrid.CurrentCell.Renderer.ControlValue.ToString();
                               (this.Gantt.GanttGrid.InternalGrid.Nodes[i-1].Item as TaskDetails).TaskName = text;
                            }
                        }
                    }
                }
            }
         }

        private void Gantt_Loaded(object sender, RoutedEventArgs e)
        {
            this.Gantt.GanttGrid.EnableHotRowMarker = false;
            this.Gantt.GanttGrid.NotifyPropertyChanges = true;
            this.Gantt.GanttGrid.EnableNodeSelection = true;
            this.Gantt.GanttGrid.EnableSelections = true;
            this.Gantt.GanttGrid.ExpandStateAtStartUp = GridTreeStartUpExpandState.RootNodesExpanded;
            Binding binding = new Binding();
            binding.Source = this.chk_Allow;
            binding.Path = new PropertyPath("IsChecked");
            binding.Converter = this.RootGrid.Resources["readOnlyConverter"] as ReadOnlyConverter;
            this.Gantt.GanttGrid.SetBinding(GridTreeControl.ReadOnlyProperty, binding);
            this.Gantt.GanttGrid.InternalGrid.Model.Options.ListBoxSelectionMode = Syncfusion.Windows.Controls.Grid.GridSelectionMode.None;
            this.Gantt.GanttGrid.InternalGrid.CurrentCellChanged += InternalGrid_CurrentCellChanged;

            if (Gantt.GanttGrid != null && Gantt.GanttGrid.InternalGrid != null)
            {
                if (ActivateCurrentCell.SelectedIndex == 0)
                {
                    Gantt.GanttGrid.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.ClickOnCell;
                }
                else if (ActivateCurrentCell.SelectedIndex == 1)
                {
                    Gantt.GanttGrid.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.DblClickOnCell;
                }
            }
        }

        private void ActivateCurrentCell_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ComboBox comboBox = sender as ComboBox;
            if (Gantt.GanttGrid != null && Gantt.GanttGrid.InternalGrid != null)
            {
                if (comboBox.SelectedIndex == 0)
                {
                    Gantt.GanttGrid.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.ClickOnCell;
                }
                else if (comboBox.SelectedIndex == 1)
                {
                    Gantt.GanttGrid.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.DblClickOnCell;
                }
            }
        }
    }
}